package web.multitask.trismegistoservices.api;

import org.json.JSONObject;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import web.multitask.trismegistoservices.model.DriveRequest;
import web.multitask.trismegistoservices.services.DriveService;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("drive")
public class DriveApi {

   DriveService driveService;

   public DriveApi(DriveService driveService) {
      this.driveService = driveService;
   }

   @PostMapping(path = "/public/upload", consumes = { MediaType.MULTIPART_FORM_DATA_VALUE })
   public ResponseEntity<?> uploadFile(@ModelAttribute DriveRequest request) {

      String folder_id = request.getFolder_id();
      String file_name = request.getFile_name();
      // String base64_name = request.getBase64_name();
      // String base64_file = request.getBase64_file();
      MultipartFile file = request.getFile();
      String responseDrive = driveService.uploadFile(folder_id, file_name, file, new JSONObject());
      JSONObject response = new JSONObject();
      if(responseDrive == null){
         response.put("status", "error");
         response.put("message", "Error al subir el archivo");
         return ResponseEntity.badRequest().body(response.toMap());
      }else{
         response.put("status", "success");
         response.put("message", "Archivo subido correctamente");
         response.put("file_id", responseDrive);
         return ResponseEntity.ok(response.toMap());
      }
   }

}