package web.multitask.trismegistoservices.api;

import java.io.File;
import java.io.IOException;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.FileUtils;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import web.multitask.trismegistoservices.services.ExcelService;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("excel")
public class ExcelApi {

    @Autowired
    ExcelService excelService;

    @PostMapping("/public/generate")
    public ResponseEntity<?> generateExcel(HttpServletResponse response,@RequestBody String json) {
        
        JSONObject jsonObject = new JSONObject(json);
        byte[] excelByte = excelService.generateExcel(jsonObject);
        // excelByte to InputStreamResource
        File file = new File(System.getProperty("java.io.tmpdir") + "/excel.xlsx");
        try {
            FileUtils.writeByteArrayToFile(file, excelByte);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        Resource resource = excelService.convertByteToResource(excelByte, jsonObject.optString("file_name", "no_name.xlsx"));
        return ResponseEntity.ok().body(resource);
    }
}