package web.multitask.trismegistoservices.api;

import org.json.JSONObject;
import org.springframework.core.io.ByteArrayResource;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import web.multitask.trismegistoservices.services.PDFService;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("/pdf")
public class PDFApi {

    PDFService pdfService;

    public PDFApi(PDFService pdfService) {
        this.pdfService = pdfService;
    }

    @PostMapping("/public/html")
    public ResponseEntity<?> htmlToPdf(@RequestBody String json) {
        try {
            JSONObject bodyJson = new JSONObject(json);
            HttpHeaders headers = new HttpHeaders();
            headers.add(HttpHeaders.CONTENT_DISPOSITION, "attachment; filename=" + bodyJson.getString("name"));
            ByteArrayResource resource = pdfService.htmlToPdf(bodyJson.getString("html"));
            MediaType mediaType = org.springframework.http.MediaType.APPLICATION_PDF;
            if (mediaType != null) {
                return ResponseEntity.ok().headers(headers)
                        .contentLength(resource.contentLength())
                        .contentType(mediaType)
                        .body(resource);
            } else {
                return ResponseEntity.badRequest().body("Error");
            }
        }catch (Exception e){
            System.out.println(e);
            return ResponseEntity.internalServerError().body(e.getMessage());
        }
    }

}