package web.multitask.trismegistoservices.services;

import java.io.ByteArrayInputStream;
import java.util.Collections;

import org.json.JSONObject;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import com.google.api.client.http.InputStreamContent;
import com.google.api.services.drive.model.File;

import web.multitask.trismegistoservices.config.GoogleConfig;
import web.multitask.trismegistoservices.interfaces.IDriveService;

@Service
public class DriveService implements IDriveService {

    private final GoogleConfig googleConfig;

    public DriveService(GoogleConfig googleConfig) {
        this.googleConfig = googleConfig;
    }

    @Override
    public String uploadFile(String folder_id, String file_name, MultipartFile file, JSONObject base64) {
        try {
            if (null != file) {
                File fileMetadata = new File();
                fileMetadata.setParents(Collections.singletonList(folder_id));
                fileMetadata.setName(file.getOriginalFilename());
                File uploadFile = googleConfig.getDrive()
                        .files()
                        .create(fileMetadata, new InputStreamContent(
                                file.getContentType(),
                                new ByteArrayInputStream(file.getBytes())))
                        .setFields("id").execute();
                return uploadFile.getId();
            }
        } catch (Exception e) {
            System.out.printf("Error: " + e);
        }
        return null;
    }

    @Override
    public String createFolder(String folder_id, String folder_name) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'createFolder'");
    }

    @Override
    public String deleteFile(String file_id) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'deleteFile'");
    }

    @Override
    public String deleteFolder(String folder_id) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'deleteFolder'");
    }

    @Override
    public String getFile(String file_id) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'getFile'");
    }

    @Override
    public String getFolder(String folder_id) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'getFolder'");
    }

}